package Insertion;

public class InsertionSort {
    /**
     * Sorts an array using the Insertion Sort algorithm.
     * 
     * @param arr The array to be sorted (modified in-place).
     */
    public static void insertionSort(int[] arr) {
        // Start from the second element (index 1) because the first element is already "sorted"
        for (int i = 1; i < arr.length; i++) {
            int key = arr[i]; // The element to be inserted into the sorted section
            int j = i - 1;    // Start comparing from the last element in the sorted section

            // Shift elements in the sorted section to make space for key
            while (j >= 0 && arr[j] > key) {
                arr[j + 1] = arr[j]; // Shift element one position to the right
                j--;                 // Move left in the sorted section
            }
            arr[j + 1] = key; // Insert the key into the correct position
        }
    }

    /**
     * Main method to test Insertion Sort.
     */
    public static void main(String[] args) {
        int[] arr = {5, 3, 8, 4, 2}; // Example array
        System.out.println("Original array:");
        printArray(arr);

        insertionSort(arr); // Sort the array

        System.out.println("Sorted array:");
        printArray(arr);
    }

    /**
     * Helper method to print an array.
     * 
     * @param arr The array to print.
     */
    public static void printArray(int[] arr) {
        for (int num : arr) {
            System.out.print(num + " ");
        }
        System.out.println(); // Move to a new line
    }
}

